#%RAML 0.8
title: Level-1 Page
version: v0
baseUri: /api/{version}

securitySchemes:
  - JWT:
      type: x-JWT
      description:
        This API uses JWT to authenticate the requests.
        See jwt.io for more information.
      describedBy:
        headers:
          Authorization:
            description: |
              Should contain the JWT token.
              Format of the value is : JWT $token
        responses:
          401:
            description: Missing or invalid JWT token
          403:
            description: Insufficient privileges
securedBy: [ null, JWT ]

resourceTypes:
  - readOnly:
      get:
        description: <<description>>
        responses:
          200:
            body:
              application/json:
                schema: <<responseSchema>>
                example: <<exampleJSON>>
  - controller:
      post:
        description: <<description>>
        responses:
          200:
            body:
              application/json:
                example: <<exampleJSON>>

/whoami:
  type:
    readOnly:
      description: Verifies a given JWT token and returns the JWT payload.
      exampleJSON: !include examples/getWhoami.json
      responseSchema: !include schemas/empty.json

/subsystems:
  type:
    readOnly:
      description: Get a list of all subsystems and their status
      exampleJSON: !include examples/getSubsystems.json
      responseSchema: !include schemas/getSubsystems.json
  /{subsystemName}:
    type:
      readOnly:
        description: Get a subsystem and its status
        exampleJSON: !include examples/getSubsystem.json
        responseSchema: !include schemas/getSubsystem.json
    uriParameters:
     subsystemName:
       displayName: Subsystem name
       type: string
       example: BMTF

/run:
  type:
    readOnly:
      description: Gets the current run info
      exampleJSON: !include examples/getRun.json
      responseSchema: !include schemas/getRun.json

/config:
  type:
    readOnly:
      description: Empty endpoint to config endpoints
      exampleJSON: !include examples/empty.json
      responseSchema: !include schemas/empty.json
  /subsystems:
    type:
      readOnly:
        description: Gets the config for L1Page regarding subsystems
        exampleJSON: !include examples/getSubsystemsConfig.json
        responseSchema: !include schemas/getSubsystemConfig.json

  /links:
    type:
      readOnly:
        description: Get a list of external apps and their hyperlinks
        exampleJSON: !include examples/getLinks.json
        responseSchema: !include schemas/getLinks.json

/shifter-information:
  type:
    readOnly:
      description: Get a list of external apps and their hyperlinks
      exampleJSON: !include examples/getShifterInformation.json
      responseSchema: !include schemas/getShifterInformation.json
  post:
    description: Insert a new entry in the shifter information list
    responses:
      200:
        body:
          application/json:
            example: !include examples/postShifterInformation.json

/flashlist:
  type:
    readOnly:
      description: Get the latest version of the TS flashlist in raw JSON
      exampleJSON: !include examples/getFlashlist.json
      responseSchema: !include schemas/getFlashlist.json

/suggestions:
  type:
    readOnly:
      description: Get the current list of suggestions
      exampleJSON: !include examples/getSuggestions.json
      responseSchema: !include schemas/getSuggestions.json
